# coding: utf-8

"""
    LUSID API

    FINBOURNE Technology  # noqa: E501

    Contact: info@finbourne.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, Dict
from pydantic.v1 import BaseModel, Field, constr, validator

class WorkspaceCreationRequest(BaseModel):
    """
    A request to create an empty workspace.  # noqa: E501
    """
    name: constr(strict=True, max_length=64, min_length=1) = Field(..., description="A workspace's name; a unique identifier.")
    description: constr(strict=True, max_length=6000, min_length=0) = Field(..., description="A friendly description for the workspace.")
    __properties = ["name", "description"]

    @validator('name')
    def name_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if not re.match(r"^[a-zA-Z0-9\-_]+$", value):
            raise ValueError(r"must validate the regular expression /^[a-zA-Z0-9\-_]+$/")
        return value

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> WorkspaceCreationRequest:
        """Create an instance of WorkspaceCreationRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> WorkspaceCreationRequest:
        """Create an instance of WorkspaceCreationRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return WorkspaceCreationRequest.parse_obj(obj)

        _obj = WorkspaceCreationRequest.parse_obj({
            "name": obj.get("name"),
            "description": obj.get("description")
        })
        return _obj
